#include "Form1.h"

#include <unistd.h>
#include <sys/io.h>
#include <stdio.h>
#include <time.h>
#include <qcheckbox.h>
#include <qtimer.h>
//#include <qtooltip.h>
int p1,p2,p3,p4,in,port=0x3f8;

Form1::Form1(QWidget * parent, const char * name, WFlags f):QWidget(parent, name, f)
{
  system("echo 15>>/dev/ttyS0");
  c1 = new QCheckBox(this,"CheckBox1");
  c2 = new QCheckBox(this,"CheckBox2");
  c3 = new QCheckBox(this,"CheckBox3");
  c4 = new QCheckBox(this,"CheckBox4");
  c5 = new QCheckBox(this,"CheckBox5");
  t1 = new QTimer(this,"Timer1");

  tip1->add(c1,"Lozko BercikaLozko Franca");
  tip2->add(c2,"Dwie lampy pokojowe o duzej wydajnosci pobierajace energie z gniazda 220V 50Hz");
  tip3->add(c3,"Lampa nad komputerem");
  tip4->add(c4,"Lozko Franca");
  tip5->add(c5,"Blokada stanow");
  t1->start(1000);
  c1->setGeometry( 0,0,15,13);
  c2->setGeometry(13,0,30,13);
  c3->setGeometry(26,0,45,13);
  c4->setGeometry(39,0,60,13);
  c5->setGeometry(52,0,75,13);
  connect( c1, SIGNAL(toggled(bool)), this, SLOT(set1(bool)) );
  connect( c2, SIGNAL(toggled(bool)), this, SLOT(set2(bool)) );
  connect( c3, SIGNAL(toggled(bool)), this, SLOT(set3(bool)) );
  connect( c4, SIGNAL(toggled(bool)), this, SLOT(set4(bool)) );
  connect( c5, SIGNAL(toggled(bool)), this, SLOT(badanie_stanow(bool)) );
  connect( t1, SIGNAL(timeout()), this, SLOT(stat()) );
}

Form1::~Form1()
{

}

/////////////////////////////////////////////////////////////////
void Form1::set1( bool status )
{
t1->stop();
if(status==1)
{
 outb(100,port);
}else
{
 outb(101,port);
}
t1->start(1000);
}
/////////////////////////////////////////////////////////////////
void Form1::set2( bool status )
{
t1->stop();
if(status==1)
{
 outb(102,port);
}else
{
 outb(103,port);
}
t1->start(1000);
}
/////////////////////////////////////////////////////////////////
void Form1::set3( bool status )
{
t1->stop();
if(status==1)
{
 outb(104,port);
}else
{
 outb(105,port);
}
t1->start(1000);
}
/////////////////////////////////////////////////////////////////
void Form1::set4( bool status )
{
t1->stop();
if(status==1)
{
 outb(106,port);
}else
{
 outb(107,port);
}
t1->start(1000);
}
/////////////////////////////////////////////////////////////////
void Form1::badanie_stanow( bool status )
{
stany[0]=c1->isChecked();
stany[1]=c2->isChecked();
stany[2]=c3->isChecked();
stany[3]=c4->isChecked();
}
/////////////////////////////////////////////////////////////////
void Form1::stat()
{
ioperm(8,port,0x3ff);
in=inb(port);                               //pobierz dane z COm'u
	switch(in)                          //badanie stanu kanalow
	{
	case 0:
	p1=0;
	p2=0;
	p3=0;
	p4=0;
	break;
	case 1:
	p1=1;
	p2=0;
	p3=0;
	p4=0;
	break;
	case 2:
	p1=0;
	p2=1;
	p3=0;
	p4=0;
	break;
	case 3:
	p1=1;
	p2=1;
	p3=0;
	p4=0;
	break;
	case 4:
	p1=0;
	p2=0;
	p3=1;
	p4=0;
	break;
	case 5:
	p1=1;
	p2=0;
	p3=1;
	p4=0;
	break;
	case 6:
	p1=0;
	p2=1;
	p3=1;
	p4=0;
	break;
	case 7:
	p1=1;
	p2=1;
	p3=1;
	p4=0;
	break;
	case 8:
	p1=0;
	p2=0;
	p3=0;
	p4=1;
	break;
	case 9:
	p1=1;
	p2=0;
	p3=0;
	p4=1;
	break;
	case 10:
	p1=0;
	p2=1;
	p3=0;
	p4=1;
	break;
	case 11:
	p1=1;
	p2=1;
	p3=0;
	p4=1;
	break;
	case 12:
	p1=0;
	p2=0;
	p3=1;
	p4=1;
	break;
	case 13:
	p1=1;
	p2=0;
	p3=1;
	p4=1;
	break;
	case 14:
	p1=0;
	p2=1;
	p3=1;
	p4=1;
	break;
	case 15:
	p1=1;
	p2=1;
	p3=1;
	p4=1;
	break;
	}
if (p1==1){c1->setChecked(1);}else{c1->setChecked(0);}
if (p2==1){c2->setChecked(1);}else{c2->setChecked(0);}
if (p3==1){c3->setChecked(1);}else{c3->setChecked(0);}
if (p4==1){c4->setChecked(1);}else{c4->setChecked(0);}
time_t rawtime;
struct tm * timeinfo;

time ( &rawtime );
timeinfo = localtime ( &rawtime );

if(timeinfo->tm_hour<5||timeinfo->tm_hour>10)
{
 if (c5->isChecked()==1)
 {
  c1->setEnabled(false);c1->setChecked(stany[0]);
  c2->setEnabled(false);c2->setChecked(stany[1]);
  c3->setEnabled(false);c3->setChecked(stany[2]);
  c4->setEnabled(false);c4->setChecked(stany[3]);
 }else
 {
  c1->setEnabled(true);
  c2->setEnabled(true);
  c3->setEnabled(true);
  c4->setEnabled(true);
 }
}else
{
 stany[0]=c1->isChecked();
 stany[1]=c2->isChecked();
 stany[2]=c3->isChecked();
 stany[3]=c4->isChecked();
 c1->setEnabled(true);
 c2->setEnabled(true);
 c3->setEnabled(true);
 c4->setEnabled(true);
}
}

